/**
 * 
 */
package model.drawables;

import java.awt.Color;
import java.awt.Graphics;

/**
 * Circle Klasse, die einen Kreis mit dem Bresenham-Algorithmus zeichen kann.
 * Der Kreis wird im XOR-Modus gestrichelt gezeichnet.
 * 
 * @author Nicolas Neubauer
 * 
 */
public class DashedCircle extends Circle {

	private int steps;

	/**
	 * @param x
	 * @param y
	 * @param r
	 * @see Circle
	 */
	public DashedCircle(int x, int y, int r) {
		super(x, y, r);
		steps = 0;
	}

	/**
	 * @param m
	 * @param r
	 * @see Circle
	 */
	public DashedCircle(Point m, int r) {
		super(m, r);
		steps = 0;
	}

	/**
	 * Setzt nur jedes drittel Pixel im XOR-Modus
	 */
	protected void setPixel(int x, int y, Graphics g) {

		if (((steps++ / 3) % 2) == 0) {
			g.setXORMode(Color.CYAN);
			super.setPixel(x, y, g);
			g.setPaintMode();
		}

	}

}
