package view;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridLayout;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JTextField;

/**
 * @author Nicolas Neubauer
 * 
 */
@SuppressWarnings("serial")
public class MatrixPanel extends JPanel {

	// TextFields
	private JTextField[][] textFields;

	// MatrixList
	private JList matrixList;

	// Buttons
	private JButton addButton;
	private JButton popButton;
	private JButton clearButton;

	private JPanel centerPanel;

	/**
	 * Erzeugt ein neues Panel mit der Möglichkeit zur Matrizeneingabe und
	 * Listendarstellung.
	 */
	public MatrixPanel() {
		this.setLayout(new BorderLayout());

		// Create Label
		JLabel l = new JLabel("Matrix-Stack");
		this.add(l, BorderLayout.NORTH);

		centerPanel = new JPanel();
		centerPanel.setLayout(new BorderLayout());

		// Create 3x3 TextFields in new JPanel
		JPanel fieldPanel = new JPanel();
		fieldPanel.setLayout(new GridLayout(3, 3));

		textFields = new JTextField[3][3];

		for (int row = 0; row < 3; row++) {
			for (int col = 0; col < 3; col++) {
				textFields[row][col] = new JTextField();
				textFields[row][col].setText("0");
				fieldPanel.add(textFields[row][col]);
			}
		}

		textFields[0][0].setText("1");
		textFields[0][2].setText("-5");
		textFields[1][2].setText("-5");
		textFields[1][1].setText("1");
		textFields[2][2].setText("1");

		centerPanel.add(fieldPanel, BorderLayout.NORTH);

		// Matrix List
		matrixList = new JList();
		matrixList.setPreferredSize(new Dimension(300, 0));
		matrixList.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
		centerPanel.add(matrixList, BorderLayout.CENTER);

		this.add(centerPanel, BorderLayout.CENTER);

		// Buttons
		JPanel buttonPanel = new JPanel();
		buttonPanel.setLayout(new BorderLayout());

		addButton = new JButton("Push");
		popButton = new JButton("Pop");
		clearButton = new JButton("Leeren");

		buttonPanel.add(addButton, BorderLayout.WEST);
		buttonPanel.add(popButton, BorderLayout.CENTER);
		buttonPanel.add(clearButton, BorderLayout.EAST);

		this.add(buttonPanel, BorderLayout.SOUTH);

	}

	/**
	 * @return Currently selected Index
	 */
	public int getSelectedIndex() {
		if (!matrixList.isSelectionEmpty()) {
			return matrixList.getSelectedIndex();
		}
		return -1;
	}

	/**
	 * @return the textFields
	 */
	public JTextField[][] getTextFields() {
		return textFields;
	}

	/**
	 * @return the matrixList
	 */
	public JList getMatrixList() {
		return matrixList;
	}

	/**
	 * @return the addButton
	 */
	public JButton getAddButton() {
		return addButton;
	}

	/**
	 * @return the popButton
	 */
	public JButton getPopButton() {
		return popButton;
	}

	/**
	 * @return the clearButton
	 */
	public JButton getClearButton() {
		return clearButton;
	}

}
